#include <ppltasks.h>
using namespace concurrency;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::ApplicationModel::Background;
using namespace Windows::ApplicationModel::AppService;

// These functions should be defined in the sketch file
void resetSignal();
void setup();
void loop();
bool getSignal(unsigned int **sdata, int *dataLen);

namespace BgApp
{
	[Windows::Foundation::Metadata::WebHostHidden]
	public ref class StartupTask sealed : public IBackgroundTask
	{
	private:
		AppServiceConnection^ appcon = nullptr;

	public:
		virtual void Run(IBackgroundTaskInstance^ taskInstance) 
		{
			auto deferral = taskInstance->GetDeferral();

			AppServiceTriggerDetails^ triggerDetails = dynamic_cast<AppServiceTriggerDetails^>(taskInstance->TriggerDetails);
			appcon = triggerDetails->AppServiceConnection;
			//appcon->RequestReceived +=
			//	ref new TypedEventHandler<AppServiceConnection^, AppServiceRequestReceivedEventArgs^>
			//	(this, &StartupTask::OnConnectionReceived);

			unsigned int *data;
			int dataLen;

			setup();
			while (true)
			{
				loop();

				if (getSignal(&data, &dataLen) == true) {
					auto sendData = ref new Array<unsigned int>(data, dataLen);
					auto messages = ref new ValueSet();
					messages->Insert("infrared", sendData);
					try {
						create_task(appcon->SendMessageAsync(messages)).wait();
					}catch(Exception ^ex){ }
					resetSignal();
				}
			}
		}
	};
}
